#ifndef _COLLISION_H
#define _COLLISION_H

#include "Plane.h"
#include "Ball.h"

class Collision {

	Ball* firstObject;	// one object is always a ball
	void* secondObject;	// the other object can be a ball or a plane

	Plane plane;	// if the other object is a plane, it is stored here

	float t;	// used to determine the touching point, describes time when it occured

public:

	Collision();

	Collision(Ball *b, Plane &p, float d);

	Collision(Ball *b1, Ball *b2, float d=0);

	Collision(const Collision& c);

	float getT() const;

	bool isEmpty() const;

	Collision& operator=(const Collision& c);
	
	void handle();	// solve the collision (compute new speed vectors)
};

#endif
