// cuboid is like a box - 6 perpendicular sides

#ifndef _CUBOID_H
#define _CUBOID_H

#include "GameObject.h"
#include "Wall.h"
#include "Plane.h"
#include <QColor>
#include "globals.h"
#include "Collision.h"

class Point;
class Direction;
class Ball;

class Cuboid : public GameObject {
    
    Wall walls[6];	// 6 walls of the cuboid

	Point center;	// central point of the cuboid

	float radius;	// radius of the bounding sphere

  public:
	Cuboid();
    
	Cuboid(const Point & ppoint, const Direction & dir1, const Direction & dir2, const Direction & dir3, const QColor & color);

    // given a ball, it will find a colliding plane (it can be a cuboid wall or a new computed plane)
	Collision findCollisionPlane(Ball *ball) const throw(insideCuboidException);

    virtual void draw() const;

	virtual bool colliding(const Ball& b) const;	// is there a collision - this is the simplest collision detection using bounding sphere

};
#endif
