#include "Cue.h"
#include <QtOpenGL>

// constructor
Cue::Cue() : position(0,0,0), direction(Point(0,0,0), Point(0,0,0)) {
}

// position setter
void Cue::setPosition(const Point& pos) {
	position = pos;
}

// direction setter
void Cue::setDirection(const Direction& dir) {
	direction = dir;
}

// direction gettter
Direction Cue::getDirection() const {
	return direction;
}

// position getter
Point Cue::getPosition() const {
	return position;
}

// draw itself on the screen - OpenGL
void Cue::draw() const {
	Point p1, p2;
	p1 = position + (-direction.normalized()*2*RADIUS_WHITE);
	p2 = p1 + (-direction.normalized()*CUE_LENGTH) + Direction(0,0,4*TABLE_MARGIN);
	
	glColor3i(CUE_COLOR);
	glLineWidth(4);
	glBegin(GL_LINES);
	glVertex3f(p1.getX(), p1.getY(), p1.getZ());
	glVertex3f(p2.getX(), p2.getY(), p2.getZ());
	glEnd();
}

