// represents a mathematical plane

#ifndef _PLANE_H
#define _PLANE_H


#include "globals.h"
#include "Point.h"
#include "Direction.h"
#include <stdio.h>
#include <math.h>

class Ball;

class Plane {
  protected:
    //d from the equation 0=ax+by+cz+d
    float d;

    Point point;

    //(a,b,c) from the equation 0=ax+by+cz+d
    Direction normal;


  public:
    Plane(const Point & ppoint, const Direction &dir1, const Direction &dir2);

	Plane(const Point & ppoint, const Direction & pnormal);
	
	Plane();

	Plane(const Plane&p);

    float distance(const Ball & ball) const;

    float getA() const;

    float getB() const;

    float getC() const;

    float getD() const;

	Direction getNormal() const;

	Point getPoint() const;

	bool isNull() const;

	Point findIntersection(const Point& p, const Direction& d) const;	// compute point of intersection of the plane and a direction vector

};
#endif
