// represents a mathematical point

#include "Point.h"

Point::Point() : x(0), y(0), z(0) {}

Point::Point(float px, float py, float pz) : x(px), y(py), z(pz) {
}

Point::Point(const Point& point) : x(point.getX()), y(point.getY()), z(point.getZ()) {
}

Point Point::operator+(const Direction & dir) const {
	return Point(x+dir.getX(), y+dir.getY(), z+dir.getZ()); 
}

Direction Point::operator-(const Point & point) const {
	return Direction(point, *this);
}

Point& Point::operator=(const Point& point) {
	x = point.getX();
	y = point.getY();
	z = point.getZ();
	return *this;
}

bool Point::operator==(const Point& p) const {
	return (x==p.getX() && y==p.getY() && z==p.getZ());
}

float Point::getX() const {
	return x;
}

float Point::getY() const {
	return y;
}

float Point::getZ() const {
	return z;
}

