// one wall of the cuboid

#include "Wall.h"
#include "Point.h"
#include <QtOpenGL>

Wall::Wall() : Plane(), direction1(0,0,0), direction2(0,0,0) {
}

Wall::Wall(const Point & ppoint, const Direction & dir1, const Direction & dir2, const QColor& pcolor) : Plane(ppoint, dir1, dir2), direction1(dir1), direction2(dir2), color(pcolor) {
}

/* draw on the screen */
void Wall::draw() const {
	glColor3f((float)color.red()/255, (float)color.green()/255, (float)color.blue()/255);
	glBegin(GL_POLYGON);
		glNormal3f(normal.getX(), normal.getY(), normal.getZ());
		glVertex3f(point.getX(), point.getY(), point.getZ());
		glVertex3f(point.getX()+direction1.getX(), point.getY()+direction1.getY(), point.getZ()+direction1.getZ());
		glVertex3f(point.getX()+direction1.getX()+direction2.getX(), point.getY()+direction1.getY()+direction2.getY(), point.getZ()+direction1.getZ()+direction2.getZ());
		glVertex3f(point.getX()+direction2.getX(), point.getY()+direction2.getY(), point.getZ()+direction2.getZ());
	glEnd();
}

// get all 4 points that describe the wall
WallPoints Wall::getPoints() const {
	return WallPoints(Point(point), Point(point+direction1), Point(point+direction1+direction2), Point(point+direction2));
}
